<div class="sub-page-container">
  <!-- Title -->
  <h1>{{ 'parameter.cabling.title' | translate }}</h1>
  <mat-divider></mat-divider>
  <div class="sub-page-body" *ngIf="cabling | async; let cables">
    <div class="left-container" *ngIf="$schema | async; let schema">
      <div class="grid">
        <!-- 
            Strategy
           -->
        <div class="grid-item strategy">
          <div class="title">
            <h2>{{ 'parameter.cabling.structure' | translate }}</h2>
            <mat-icon
              [matTooltip]="
                'parameter.cabling.structureDescription' | translate
              "
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <mat-radio-group
            class="radio-container"
            #matSelect_cabling_strategy
            disableOptionCentering
            [(ngModel)]="cables.structure"
          >
            <mat-radio-button value="string"
              >{{ 'parameter.cabling.string' | translate }}
            </mat-radio-button>
            <mat-radio-button value="closed-loop"
              >{{ 'parameter.cabling.closedLoop' | translate }}
            </mat-radio-button>
          </mat-radio-group>
        </div>
        <!-- 
          Power Loss Factor
         -->
        <div class="grid-item power-loss-factor">
          <div class="title">
            <h2>{{ 'parameter.cabling.pwrLossFactor' | translate }}</h2>
            <mat-icon
              [matTooltip]="
                'parameter.cabling.pwrLossFactorDescription' | translate
              "
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <energy-platform-parameter-slider
            #pwrLossFactor
            [unit]="schema.cabling.properties.power_loss_percentage.unit"
            [min]="schema.cabling.properties.power_loss_percentage.minimum"
            [max]="schema.cabling.properties.power_loss_percentage.maximum"
            [step]="schema.cabling.properties.power_loss_percentage.step"
            [value]="cables.power_loss_percentage"
            (valueChange)="cables.power_loss_percentage = $event; validate()"
          >
          </energy-platform-parameter-slider>
        </div>
        <!-- 
          Cable Voltage
         -->
        <div class="grid-item cable-voltage">
          <div class="title">
            <h2>{{ 'parameter.cabling.cblVoltg' | translate }}</h2>
            <mat-icon
              [matTooltip]="'parameter.cabling.cblVoltgDescription' | translate"
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <energy-platform-parameter-slider
            #cblVoltg
            [unit]="schema.cabling.properties.cable_voltage.unit"
            [min]="schema.cabling.properties.cable_voltage.minimum"
            [max]="schema.cabling.properties.cable_voltage.maximum"
            [step]="schema.cabling.properties.cable_voltage.step"
            [value]="cables.cable_voltage"
            (valueChange)="cables.cable_voltage = $event; validate()"
          ></energy-platform-parameter-slider>
        </div>
        <!-- 
          Frequence of Current
         -->
        <div class="grid-item frequence-of-current">
          <div class="title">
            <h2>{{ 'parameter.cabling.currFreq' | translate }}</h2>
            <mat-icon
              [matTooltip]="'parameter.cabling.currFreqDescription' | translate"
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <energy-platform-parameter-slider
            #currFreq
            [unit]="schema.cabling.properties.site_main_frequency.unit"
            [min]="schema.cabling.properties.site_main_frequency.minimum"
            [max]="schema.cabling.properties.site_main_frequency.maximum"
            [step]="schema.cabling.properties.site_main_frequency.step"
            [value]="cables.site_main_frequency"
            (valueChange)="cables.site_main_frequency = $event; validate()"
          ></energy-platform-parameter-slider>
        </div>
        <!-- 
          Costs for Turbine-Cable Connection
         -->
        <div class="grid-item cost-for-turbine-cable-connection">
          <div class="title">
            <h2>{{ 'parameter.cabling.turbCableConCost' | translate }}</h2>
            <mat-icon
              [matTooltip]="
                'parameter.cabling.turbCableConCostDescription' | translate
              "
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <energy-platform-parameter-slider
            #turbCableConCost
            [unit]="schema.cabling.properties.cost_cable_connect.unit"
            [min]="schema.cabling.properties.cost_cable_connect.minimum"
            [max]="schema.cabling.properties.cost_cable_connect.maximum"
            [step]="schema.cabling.properties.cost_cable_connect.step"
            [value]="cables.cost_cable_connect"
            (valueChange)="cables.cost_cable_connect = $event"
          ></energy-platform-parameter-slider>
        </div>
        <!-- 
          Costs for Turbine Safety-Generator
         -->
        <div class="grid-item costs-for-turbine-safety-generator">
          <div class="title">
            <h2>{{ 'parameter.cabling.safetyGen' | translate }}</h2>
            <mat-icon
              [matTooltip]="
                'parameter.cabling.safetyGenDescription' | translate
              "
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <energy-platform-parameter-slider
            #safetyGen
            [unit]="schema.cabling.properties.cost_generator.unit"
            [min]="schema.cabling.properties.cost_generator.minimum"
            [max]="schema.cabling.properties.cost_generator.maximum"
            [step]="schema.cabling.properties.cost_generator.step"
            [value]="cables.cost_generator"
            (valueChange)="cables.cost_generator = $event; validate()"
          ></energy-platform-parameter-slider>
        </div>
        <!-- 
          Automatically Select Best Cables Using A Maximum number of Cables
         -->
        <div class="grid-item auto-select-cable">
          <div class="title">
            <h2>{{ 'parameter.cabling.autoBest' | translate }}</h2>
            <mat-icon
              [matTooltip]="'parameter.cabling.autoBestDescription' | translate"
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <energy-platform-parameter-slider
            #autoBest
            [unit]="schema.cabling.properties.max_cable_types.unit"
            [min]="schema.cabling.properties.max_cable_types.minimum"
            [max]="schema.cabling.properties.max_cable_types.maximum"
            [step]="schema.cabling.properties.max_cable_types.step"
            [value]="cables.max_cable_types"
            (valueChange)="cables.max_cable_types = $event; validate()"
          ></energy-platform-parameter-slider>
        </div>
      </div>

      <!--
      Save Button
      -->
      <button
        mat-button
        [disabled]="
          !buttonValidator([
            pwrLossFactor,
            cblVoltg,
            currFreq,
            turbCableConCost,
            safetyGen,
            autoBest
          ])
        "
        class="pill-button save-button"
        (click)="onSave()"
      >
        {{ 'parameter.general.save' | translate }}
      </button>
    </div>

    <div class="right-container">
      <div class="grid">
        <!-- 
          Cable Types [*]
        -->
        <div class="grid-item cable-types">
          <div class="title">
            <h2>{{ 'parameter.cabling.cblTypes' | translate }}</h2>
          </div>
          <table class="mat-table">
            <thead>
              <th class="mat-header-cell">ID</th>
              <th class="mat-header-cell">
                {{ 'parameter.cabling.cableTypes.price' | translate }}
                [€/m]
                <mat-icon
                  [matTooltip]="
                    'parameter.cabling.cableTypes.priceDescription' | translate
                  "
                  matTooltipPosition="right"
                  class="iconInfoTable icon-black icon-size-xxs"
                >
                  info_outlined
                </mat-icon>
              </th>
              <th class="mat-header-cell">
                {{ 'parameter.cabling.cableTypes.currentRating' | translate }}
                [A]
                <mat-icon
                  [matTooltip]="
                    'parameter.cabling.cableTypes.currentRatingDescription'
                      | translate
                  "
                  matTooltipPosition="right"
                >
                  info_outlined
                </mat-icon>
              </th>
              <th class="mat-header-cell">
                {{ 'parameter.cabling.cableTypes.cableCapacity' | translate }}
                [μF/km]
                <mat-icon
                  [matTooltip]="
                    'parameter.cabling.cableTypes.cableCapacityDescription'
                      | translate
                  "
                  matTooltipPosition="right"
                >
                  info_outlined
                </mat-icon>
              </th>
              <th class="mat-header-cell">
                {{ 'parameter.cabling.cableTypes.acResistance' | translate }}
                [Ω/km]
                <mat-icon
                  [matTooltip]="
                    'parameter.cabling.cableTypes.acResistanceDescription'
                      | translate
                  "
                  matTooltipPosition="right"
                >
                  info_outlined
                </mat-icon>
              </th>
              <th class="mat-header-cell">
                {{
                  'parameter.cabling.cableTypes.insulationLossFactor'
                    | translate
                }}
                [%]
                <mat-icon
                  [matTooltip]="
                    'parameter.cabling.cableTypes.insulationLossFactorDescription'
                      | translate
                  "
                  matTooltipPosition="right"
                >
                  info_outlined
                </mat-icon>
              </th>
              <th class="mat-header-cell">
                {{ 'parameter.cabling.cableTypes.remove' | translate }}
              </th>
            </thead>
            <tbody>
              <tr *ngFor="let cableType of cables.cable_types; index as i">
                <energy-platform-cable-type-row
                  [value]="cableType"
                  (valueChange)="cables.cable_types[i] = $event; validate()"
                  (delete)="deleteCableType(i)"
                >
                </energy-platform-cable-type-row>
              </tr>
            </tbody>
          </table>
          <button
            mat-button
            type="submit"
            class="stroked-pill-button"
            [matTooltip]="'parameter.cabling.cableTypes.addCable' | translate"
            matTooltipPosition="above"
            (click)="addCablingType()"
          >
            <mat-icon>add</mat-icon>
          </button>
        </div>
      </div>
    </div>
  </div>
</div>
